%undefine _missing_build_ids_terminate_build
%global _unpackaged_files_terminate_build 1
%global debug_package %{nil}

%if %{defined _project}
# define if building on openSUSE build service
%global build_on_obs       1
%global reconfigure_mode   0
%else
%define _project           local
%global build_on_obs       0
%global reconfigure_mode   0
%global _hardened_build    1
%endif
%global _prefix            /usr
%global sysconfdir         /etc/mpdev
%global logdir             /var/log/svc/mpdev

Name: mpdev
Version: 1.0
Release: 1.1%{?dist}
Summary: MPD Event Watcher
%if %build_on_obs == 1
License: GPL-3.0+
%else
License: GPLv3
%endif
URL: https://github.com/mbhangui/mpdev
Source0: http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.gz

%if %build_on_obs == 1
%if 0%{?suse_version}
BuildRequires: -post-build-checks
#!BuildIgnore: post-build-checks  
%endif
%endif
BuildRequires: libqmail-devel libqmail
%if %{defined suse_version} || %{defined sles_version}
BuildRequires: libsqlite3-0 sqlite3-devel
%else
BuildRequires: sqlite-libs sqlite-devel
%endif
Requires: user(qmaill)
Requires: group(nofiles)
Requires: /usr/bin/mpd /usr/bin/mpc /usr/bin/sqlite3 daemontools coreutils

%description
mpdev is a daemon, written in C, that watches a Music Player Daemon events,
using mpd's idle command and execs user defined script on event changes.

 * Uses mpd's idle mode.
 * Calls user scripts in $HOME/.mpdev (player, playpause, output)
 * Sets special environment variables to pass data to the hooks.
 * Optional support for scrobbling to last.fm, libre.fm through external scripts
 * Included scripts:
   - scrobbler
     + librefm-scrobbler
     + lastfm-scrobbler
   - player
     + saves song data to a sqlite database
     + tracks play count of songs, artist, albums and genres.
     + helps chose songs based on listening habits using mpdplaylist
       playlist generator
     + synchronizes rompr, stats and mpd's sticker db

%prep
%autosetup

%build
%configure --prefix=%{_prefix} --sysconfdir=/etc/mpdev \
  --libexecdir=%{_prefix}/libexec/mpdev
%{__make} -s %{?_smp_mflags}
(
echo "---------------- INFORMATION ------------------------"
echo target         %_target
echo target_alias   %_target_alias
echo target_cpu     %_target_cpu
echo target_os      %_target_os
echo target_vendor  %_target_vendor
echo Project        %{_project}
echo Building %{name}-%{version}-%{release} Build %{_build} OS %{_os}
echo "------------------------------------------------------"
) > %{name}-rpm.info

%install
%{__make} -s DESTDIR=%{buildroot} install-strip
%{__mkdir_p} %{buildroot}%{sysconfdir}
install -m 0644 %{name}-rpm.info %{buildroot}%{sysconfdir}/%{name}-rpm.info

%files
%dir %attr(755,root,root)               %{_prefix}/libexec/mpdev
%ghost %dir %attr(0755,qmaill,nofiles)  %{logdir}
%ghost      %attr(-,qmaill,nofiles)     %{logdir}/*
%attr(755,root,root)                    %{_prefix}/bin/mpdev
%attr(755,root,root)                    %{_prefix}/bin/mpdplaylist
%attr(755,root,root)                    %{_prefix}/bin/karma
%attr(755,root,root)                    %{_prefix}/bin/songi
%attr(755,root,root)                    %{_prefix}/bin/romprhist
%attr(755,root,root)                    %{_prefix}/bin/transfer_play
%attr(755,root,root)                    %{_prefix}/bin/lastfm-scrobbler
%attr(755,root,root)                    %{_prefix}/bin/librefm-scrobbler
%attr(755,root,root)                    %{_prefix}/libexec/mpdev/mpdev_update
%attr(755,root,root)                    %{_prefix}/libexec/mpdev/mpdev_cleanup
%attr(755,root,root)                    %{_prefix}/libexec/mpdev/mpdev_rename
%attr(755,root,root)                    %{_prefix}/libexec/mpdev/create_service
%attr(755,root,root)                    %{_prefix}/libexec/mpdev/player
%attr(755,root,root)                    %{_prefix}/libexec/mpdev/playpause
%attr(755,root,root)                    %{_prefix}/libexec/mpdev/output
%attr(755,root,root)                    %{_prefix}/libexec/mpdev/mixer
%attr(644,root,root) %config(noreplace) %{sysconfdir}/%{name}-release
%attr(644,root,root) %config(noreplace) %{sysconfdir}/%{name}-rpm.info

%attr(644,root,root)                    %{_prefix}/share/man/man1/mpdev.1.gz
%attr(644,root,root)                    %{_prefix}/share/man/man1/songi.1.gz
%attr(644,root,root)                    %{_prefix}/share/man/man1/mpdev_update.1.gz
%attr(644,root,root)                    %{_prefix}/share/man/man1/mpdev_cleanup.1.gz
%attr(644,root,root)                    %{_prefix}/share/man/man1/mpdev_rename.1.gz
%attr(644,root,root)                    %{_prefix}/share/man/man1/mpdplaylist.1.gz
%attr(644,root,root)                    %{_prefix}/share/man/man1/karma.1.gz
%attr(644,root,root)                    %{_prefix}/share/man/man1/transfer_play.1.gz
%attr(644,root,root)                    %{_prefix}/share/man/man1/romprhist.1.gz
%attr(644,root,root)                    %{_prefix}/share/man/man1/lastfm-scrobbler.1.gz
%attr(644,root,root)                    %{_prefix}/share/man/man1/librefm-scrobbler.1.gz

%license LICENSE

%docdir %{_prefix}/share/doc/%{name}
%if %build_on_obs == 0
%license %attr(644,root,root)           %{_prefix}/share/doc/%{name}/LICENSE
%license %attr(644,root,root)           %{_prefix}/share/doc/%{name}/moc-scrobbler-license
%else
%attr(644,root,root)                    %{_prefix}/share/doc/%{name}/LICENSE
%attr(644,root,root)                    %{_prefix}/share/doc/%{name}/moc-scrobbler-license
%endif
%attr(644,root,root)                    %{_prefix}/share/doc/%{name}/README.md
%attr(644,root,root)                    %{_prefix}/share/doc/%{name}/mpdev.changes

%pretrans
# stop mpdev services before upgrade
if [ -d /run ] ; then
  rundir=/run/svscan
elif [ -d /var/run ] ; then
  rundir=/var/run/svscan
else
  rundir=/service
fi
%{_prefix}/bin/svstat /service/mpdev >/dev/null 2>&1
if [ $? -eq 0 ] ; then
  %{__mkdir_p} ${rundir}/mpdev
  %{_prefix}/bin/svc -d /service/mpdev
  touch ${rundir}/mpdev/.down
fi

%post
argv1=$1
ID=$(id -u)
if [ $ID -ne 0 ] ; then
  echo "You are not root" 1>&2
  exit 1
fi
if [ -z "$argv1" ] ; then
  argv1=0
fi
# we are doing upgrade
if [ $argv1 -eq 2 ] ; then # upgrade
  if [ -d /run ] ; then
    rundir=/run/svscan
  elif [ -d /var/run ] ; then
    rundir=/var/run/svscan
  else
    rundir=/service
  fi
  # refresh mpdev services
  if [ ! -f /service/mpdev/variables/.options ] ; then
    %{__mkdir_p} /service/mpdev/variables
      echo "/usr/libexec/mpdev/create_service --servicedir=/service --user=1000 --add-service" \
        > /service/mpdev/variables/.options
  fi
  %{_prefix}/sbin/minisvc --servicedir=/service --refreshsvc="/service/mpdev" --silent
  %{_prefix}/bin/svok /service/mpdev >/dev/null 2>&1
  if [ $? -eq 0 -a -f ${rundir}/mpdev/.down ] ; then
    %{__rm} -f ${rundir}/mpdev/.down
    %{_prefix}/bin/svc -u /service/mpdev
  fi
  exit 0
fi
/usr/libexec/mpdev/create_service --servicedir=/service --user=1000 --add-service
%{_prefix}/sbin/minisvc --servicedir=/service --service-name=mpdev \
  --export-variables=/service/mpdev/variables/.variables --force --silent

%preun
argv1=$1
ID=$(id -u)
if [ $ID -ne 0 ] ; then
  echo "You are not root" 1>&2
  exit 1
fi
if [ -z "$argv1" ] ; then
  argv1=0
fi
# we are doing upgrade
if [ $argv1 -eq 1 ] ; then
  exit 0
fi
echo "removing mpdev logs"
log_dir=%{logdir}
[ "$log_dir" != "/" ] && %{__rm} -fr $log_dir
echo "stopping and removing mpdev service"
/usr/libexec/mpdev/create_service --servicedir=/service --del-service

%changelog
* Tue May 10 2022 16:16:13 +0000 Manvendra Bhangui <mpdev@indimail.org> 1.0-1.1%{?dist}
Release 1.0 Start 02/03/2020
- Bump Release
- player: skip db update if NO_DB_UPDATE is defined and non-zero
- mpdplaylist: added --karma option
- removed mpdev_maintenaance
- added --options-file feature to take command line arguments from an
  options file
- player: upgrade karma as per last_played logic
- added license, README, changelogs to doc directory
- mpdplaylist: Fix for space in command line argument values
- added --silent parmeter to minisvc invocation
- added debian/source/format
- added mpdev_rename man page
- player: skip update of play_count when song is skipped
- player: display correct playcount in rompr table
- playpause: fixed end-song, pause-song getting skipped
- playpause: use SONG_PLAYED instead of ELAPSED_TIME
- renamed SONG_PLAYED to SONG_PLAYED_DURATION
- mpdev.c: reset song_played_duration when stopped
- playpause: display date in yyyy-mm-dd HH:MM:SS during play/pause
- added new script karma for manipulating song's karma value
- added more conditions for downgrade karma
- player, playpause: skip percentage calculation when SONG_PLAYED_DURATION
  is not set
- mpdev.c: removed unset of SONG_PLAYED_DURATION
- mpdev.c: fixes for SONG_PLAYED_DURATION
- mpdev.c: add elapsed time to SONG_PLAYED_DURATION if started when a song
  was already playing
- player: removed redundant code
- mpdev.c: removed get_play_state() as it had the same function as
  get_status() function
- mdev.c: get elapsed time in a single call to get the intial player state
- mpdev.c: use DISABLE_SCROBBLE env variable to disable scrobbling
- mpdev.c, player: adde code comments
- create_service: remove cleanup of /tmp/mpdev as purpose is solved by
  having it as TMPFS
- player: added log output for scrobbling
- player: sync RompR playcounts with stats.db
- player: skip update of last_played when paused to avoid karma getting
  increased
- player: refactored update of RompR playcounts
- player: fixed value of play counts in logs and RompR update
- mpdev.c: set song_played_duration when calling script for now-playing
- player: display initial song position in NewSong
- playpause: display song played duration
- mpdev.c: increment song_played_duration when prev state is not in pause
  state
- player: skip RompR playcount update when song is not fully heard
- mpdev.c: initialize elapsed variable
- fixed usage string/description in mpdev.c and man page
- fixed idle handling
- added output even with OUTPUT devices passed as env variables. Feature
  request from Markus Gerl
- report OUTPUT changes in env variable OUTPUT_CHANGED
- added script 'output'
- set env variable VOLUME on startup and on mixer level change
- 
- mpdev.c: BUGFIX: Fixed player not comining out of do idle loop
- mpdev.c: decrement count when PLAYLIST_EVENT is followed by PLAYER_EVENT
- player.in: disable UPDATE/INSERT echo statements when NO_DB_UPDATE is set
- player.in: sanitize shell input
- mpdev.c: print debug statements for verbose > 1
- create_service: fix ownership of $HOME/.mpdev
- player: fix INSERT statement for extra (last_modified) field added to sticker
  table
- player: skip db update for streams
- mpdev_update.c: added last_modified column to sticker table
- karma.in: display karma for current playing song when no options are
  provided
- use -noheader option to prevent .sqlitrc settings messing with results
- added songi script to display information from stats.db for any music
  file
- mpdev_update.c, songi.in: removed name column from song table in stats db
- karma: fixed sql statements
- player.in: fixed non-skipping of db update for streams
- karma: fixed update not working
- songi: formated for better display
- karma: set song_uri to current playing song if no options are provided
- player.in: display mysql error
- moc-scrobbler.in: removed use of source command to avoid syntax error
  caused by data in track.current, track.last
- player.in: scrobble only when PLAYER_STATE is play
- mpdplaylist.in: added --incartist, --exlartist option to include/exclude
  comma separated list of artists
- use tcpopen, pathexec_run, pathexec_env from libqmail
